//--------------------------------------------------------
#include	<windows.h>
#include	<windowsx.h>
#include	<zmouse.h>
#include	"WheelLayered.h"

#define		PUSHED					0x8000

#pragma data_seg(".sdata")
HINSTANCE	DLLInst = NULL;
HHOOK 		hHook = NULL;
HWND		hPostWnd = NULL;
#pragma data_seg()

LRESULT CALLBACK GetMsgProc(int, WPARAM, LPARAM);
BOOL SetHook(HWND);
VOID FreeHook(VOID);

//--------------------------------------------------------
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	DLLInst = hInstance;
	return TRUE;
}

//--------------------------------------------------------
BOOL SetHook(HWND hWnd)
{
	hHook = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, DLLInst, 0);
	if(hHook == NULL){
		MessageBox(NULL, "Hook Error!", APP_NAME, MB_OK);
		return FALSE;
	}
	hPostWnd = hWnd;			// ChWndۑ
	return TRUE;
}

//--------------------------------------------------------
VOID FreeHook(VOID)
{
	if(hHook != NULL){
		UnhookWindowsHookEx(hHook);		// Hook
		hHook = NULL;
	}
}

//--------------------------------------------------------
LRESULT CALLBACK GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	SHORT sState;
	PMSG pMsg;

	if(nCode == HC_ACTION){
		pMsg = (PMSG)lParam;
		switch(pMsg->message){
		case WM_MOUSEWHEEL:								// Wheel
			sState = GetKeyState(VK_RBUTTON);
			if(sState & PUSHED){						// E
				if((short)HIWORD(pMsg->wParam) < 0)		// ]
					PostMessage(hPostWnd, WM_USER, (WPARAM)FALSE, 0);
				else
					PostMessage(hPostWnd, WM_USER, (WPARAM)TRUE, 0);
			}
			break;
		}
	}
	return(CallNextHookEx(hHook, nCode, wParam, lParam));
}

